#!/usr/bin/env python

import pygame
import math
import sys
import config
from os.path import expanduser, dirname
from os import makedirs

COLOR_CESTA = pygame.color.Color("yellow")
COLOR_TRAVA = pygame.color.Color("green")
COLOR_VODA = pygame.color.Color("blue")
COLOR_PREKAZKA = pygame.color.Color("red")
COLOR_CHECKPOINT1 = pygame.color.Color("white")
COLOR_CHECKPOINT2 = pygame.color.Color("0xa0a0a0")
COLOR_CHECKPOINT3 = pygame.color.Color("0x505050")
COLOR_CHECKPOINT4 = pygame.color.Color("black")

colors_check = [COLOR_CHECKPOINT1, COLOR_CHECKPOINT2, \
COLOR_CHECKPOINT3, COLOR_CHECKPOINT4]

bila = (250, 250, 250)

class Auto:
        pygame.mixer.init()
        checkwav = pygame.mixer.Sound("./music/checkpoint.wav")
        winnerwav = pygame.mixer.Sound("./music/winner.wav")

        def __init__(self, obrazek, stinek, controls):
            self.key_up = controls["up"]
            self.key_down = controls["down"]
            self.key_left = controls["left"]
            self.key_right = controls["right"]         
            self.key_brake = controls["brake"]             
            self.upSpeed = 0
            self.carUhel = 0
            self.speedUhel = 0
            self.kontrola = 0
            self.kola = 0
            self.obrauta = pygame.image.load(obrazek)
            self.obrstin = pygame.image.load(stinek)
            self.velauta = self.obrauta.get_width()
            self.pulauta = self.velauta // 2
            self.hmotnost = self.velauta**2
            # polohu zadat potom
            self.polohax = self.velauta
            self.polohay = self.velauta
            self.laps = -1 
            self.pocetkol = 1
            self.volant = 0
            self.fontBig = pygame.font.Font(None, 90)
            self.fontSmall = pygame.font.Font(None, 40)
        
        def calcMapCorner(self, map):
            screen_w = self.screen.get_width()
            screen_h = self.screen.get_height()
            mapax = map.get_width()
            mapay = map.get_height()

            bx = self.polohax - screen_w/2
            bx = max(0, bx)
            bx = min(mapax - screen_w,  bx)
            by = self.polohay - screen_h/2
            by = max(0, by)
            by = min(mapay - screen_h,  by)
            return bx, by

        def drawCentred(self, bg):
            screen_w = self.screen.get_width()
            screen_h = self.screen.get_height()
            bx, by = self.calcMapCorner(bg)
            self.screen.blit(bg, (0, 0), (bx, by, screen_w, screen_h))

        def drawCarOn(self, screen, px, py):
            rotatedAuto = pygame.transform.rotate(self.obrauta, self.carUhel)
            rotatedStin = pygame.transform.rotate(self.obrstin, self.carUhel)
            obrRect = rotatedAuto.get_rect()
            obrRect.centerx = px
            obrRect.centery = py
            obrRectS = rotatedAuto.get_rect()
            obrRectS.centerx = px - 4
            obrRectS.centery = py + 5
            screen.blit(rotatedStin, obrRectS)
            screen.blit(rotatedAuto, obrRect)
            
        def drawSoupere(self, souper, map):
            bx, by = self.calcMapCorner(map)
            px = souper.polohax - bx
            py = souper.polohay - by
            souper.drawCarOn(self.screen, px, py)

        def draw(self, bg):
            self.drawCentred(bg)
            
        def drawNahore(self, bg):
            self.drawCentred(bg)

            rychlabarva = (250, 250, 250)

            if self.upSpeed < 0:
                rychlabarva = (250, 0, 0)
            
            
            # rychlost
            text1 = str(int(abs(self.upSpeed)*7))
            rychlost = self.fontBig.render(text1, 1, rychlabarva)
            self.screen.blit(rychlost, (self.screen.get_width() - self.fontBig.size(text1)[0] - 50, self.screen.get_height() - 80)) 
            
            text1 = "km"
            jednotka = self.fontSmall.render(text1, 2, bila)
            self.screen.blit(jednotka, (self.screen.get_width() - 45, self.screen.get_height() - 75)) 

            text1 = "___"
            jednotka = self.fontSmall.render(text1, 2, bila)
            self.screen.blit(jednotka, (self.screen.get_width() - 47, self.screen.get_height() - 72)) 
            
            text1 = "h"
            jednotka = self.fontSmall.render(text1, 2, bila)
            self.screen.blit(jednotka, (self.screen.get_width() - 35, self.screen.get_height() - 45)) 

            # pocet kol
            text2 = str(self.pocetkol) + " / " + str(config.okruhy)
            kola = self.fontBig.render(text2, 3, bila)
            self.screen.blit(kola, (20, 0))        
            
            # mereni casu
            self.sekundy = config.time // 10 % 60
            if self.sekundy <= 9:
                self.sekundy = "0" + str(self.sekundy)
            
            text3 = str(config.time / 600) + ":" + str(self.sekundy) + "." + str(config.time % 10)
            cas = self.fontSmall.render(text3, 3, bila)
            self.screen.blit(cas, (20, 60))

        def simul(self, prekazky):
            self.checkCrash(prekazky)
            # zatim kontroluji bod v prostredku
            pixel = prekazky.get_at((int(self.polohax), int(self.polohay)))
            if pixel == COLOR_PREKAZKA:
                # print "vnitrni naraz"
                self.upSpeed = -1.6 * self.upSpeed
            elif pixel == COLOR_TRAVA:
                self.upSpeed = 0.95 * self.upSpeed
            elif pixel == COLOR_VODA:
                self.upSpeed = 0.8 * self.upSpeed
            elif pixel == COLOR_CESTA:
                self.upSpeed
            elif pixel in colors_check:
                for i in range(len(colors_check)):
                    if pixel == colors_check[i]:
                        if self.kontrola == i:
                            self.laps += 1    
                            if self.laps == 4:
                                self.pocetkol += 1
                                self.laps = 0
                            self.checkwav.play()
                            if self.kontrola == 0:
                                    self.kola += 1
                            self.kontrola = (self.kontrola + 1) % len(colors_check)
                            # print "kontrola:", self.kontrola
                            break # break for cycle
            # else:
                    # print "neznamy povrch na " \ + str(self.polohax) + "x" + str(self.polohay) + ": " + str(pixel)

        #-----------------------------------------------------------------
        def checkCrash(self, prekazky):
            pulW = self.obrauta.get_width() // 2 - 12
            pulH = self.obrauta.get_height() // 2 - 10 
            stepX = self.obrauta.get_width() // 5
            stepY = self.obrauta.get_height() // 5

            autoRadian = math.radians(self.carUhel)
            self.cosAlfa = math.cos(autoRadian)
            self.sinAlfa = math.sin(autoRadian)

            for narazX in [pulW, -pulW]:
                for narazY in xrange(pulH, 0, -stepY):
                    if self.checkCrashPoint(prekazky, narazX, narazY):
                        return
                for narazY in xrange(-pulH, 0, stepY):
                    if self.checkCrashPoint(prekazky, narazX, narazY):
                        return
            for narazY in [pulH, -pulH]:
                for narazX in xrange(pulW, 0, -stepX):
                    if self.checkCrashPoint(prekazky, narazX, narazY):
                        return
                for narazX in xrange(-pulW, 0, stepX):
                    if self.checkCrashPoint(prekazky, narazX, narazY):
                        return

        def checkCrashPoint(self, prekazky, narazX, narazY):
            crash = False
            mapax = prekazky.get_width()
            mapay = prekazky.get_height()

            relX = narazX * self.cosAlfa + narazY * self.sinAlfa
            relY = narazY * self.cosAlfa - narazX * self.sinAlfa
            px = self.polohax + relX
            py = self.polohay + relY
            if 0 <= px < mapax and 0 <= py < mapay:
                pixel = prekazky.get_at((int(px), int(py)))
                if pixel == COLOR_PREKAZKA:
                    self.otocka(narazX, narazY)
                    self.odraz(relX, relY)
                    crash = True
            return crash

        def otocka(self, narazX, narazY):
            # otoc podle polohy predku
            otockaUhel = 5
            if narazX * narazY < 0:
                self.carUhel -= otockaUhel
            else:
                self.carUhel += otockaUhel
            if 4 * abs(narazY) < self.obrauta.get_height():
                self.upSpeed *= -0.6
            else:
                self.upSpeed *= 0.8

        def odraz(self, relX, relY):
            # odraz od steny
            velikostOdrazu = 0.2
            self.polohax -= velikostOdrazu * relX
            self.polohay -= velikostOdrazu * relY
        #-----------------------------------------------------------------
        def winnerDance(self):
            if self.kola >= config.okruhy + 1:
                if config.konec == 0:
                    self.pocetkol -= 1
                    self.winnerwav.play()
                    config.konec = 1
                    if config.besttime > config.time:
                        users_trackFile = expanduser("~/.wrw/") + config.trackFile
                        try:
                            readonly = open(users_trackFile)
                        except:
                            readonly = open(config.trackFile)
                        content = readonly.readlines()
                        readonly.close()

                        try:
                            score = open(users_trackFile, "w")
                        except IOError:
                            makedirs(dirname(users_trackFile), 0700)
                            score = open(users_trackFile, "w")

                        score.write(str(config.time) + "\n")             
                        score.write(config.name + "\n")
                        score.write(config.car + "\n")
                        for line in content[3:]:
                            score.write(line)
                        score.close()
            if config.konec == 1:
                if self.upSpeed == 0:
                    config.zavkonec = 0
                   # sys.exit()
            
                text = str(config.time / 600) + ":" + str(self.sekundy) + "." + str(config.time % 10)
                cas = self.fontSmall.render(text, 3, bila)
                self.screen.blit(cas, ((self.screen.get_width() - self.fontSmall.size(text)[0]) / 2, (self.screen.get_height() - self.fontSmall.size(text)[1]) / 2))

                
                #sys.exit()
        def plyn(self, velikost):
            """ Pricte k rychlosti auta dany prirustek ve smeru volantu.
            """
            uhel = self.carUhel + self.volant
            radianUhel = math.radians(uhel)
            addX = velikost * math.cos(radianUhel)
            addY = velikost * math.sin(radianUhel)
            speedUhelRadian = math.radians(self.speedUhel)
            speedX = self.upSpeed * math.cos(speedUhelRadian)
            speedY = self.upSpeed * math.sin(speedUhelRadian)
            x = addX + speedX
            y = addY + speedY
            self.upSpeed = math.hypot(x, y)
            self.speedUhel = math.degrees(math.atan2(y, x))
            if math.cos(math.radians(self.speedUhel - self.carUhel)) < 0:
                self.speedUhel = 180 + self.speedUhel
                self.upSpeed = -self.upSpeed

        def drive(self, keys):
            #NOTE: lze pouzit gnuplot na zobrazeni zavislosti: plot [-10:30] 40*exp(-abs(x)/14)
            volantik = 40 * math.exp(-abs(self.upSpeed) / 14)
            zrychli = 0.7 * math.exp(-abs(self.upSpeed) / 20)

            if keys[self.key_up]:
                self.plyn(zrychli)
                                        
            if keys[self.key_down]:
                self.plyn(-zrychli)

            # rucni brzda
            if keys[self.key_brake]:
                if self.upSpeed > 0:
                    self.upSpeed -= 0.6
                if self.upSpeed < 0:
                    self.upSpeed += 0.3
                volantik = 40
            
            # otaceni
            if keys[self.key_right]:
                self.volant -= 2
                if keys[self.key_brake]:
                    self.volant -= 40
            elif keys[self.key_left]:
                self.volant += 2
                if keys[self.key_brake]:
                    self.volant += 40
            else:
                self.volant = self.volant // 2

            self.volant = min( volantik, self.volant)
            self.volant = max( -volantik, self.volant)

           # self.volant = min(2 + 70 // (1 + abs(self.upSpeed)), self.volant)
           # self.volant = max(-2 + -70 // (1 + abs(self.upSpeed)), self.volant)

            if abs(self.volant) > 1:
                uhelSpeed = self.volant * self.upSpeed * 0.02
                self.carUhel += uhelSpeed
                self.upSpeed = self.upSpeed * 0.985
            else:
                self.volant = 0

        def fyzika(self):   
            if self.upSpeed <= -5:
                self.upSpeed = -5       
            
            if self.upSpeed <= -0.1:
                self.upSpeed += 0.1

            if self.upSpeed >= 0.1:
                self.upSpeed -= 0.1

            # zastaveni     
            if -0.1 <= self.upSpeed <= 0.1:
                self.upSpeed = 0
                
        def move(self, prekazky):
            self.simul(prekazky)

            mapax = prekazky.get_width()
            mapay = prekazky.get_height()
            
            # drzeni se na vozovce (smyky, klouzani po odrazu)
            klouzani = 0.9
            diffRadian = math.radians(self.speedUhel - self.carUhel)
            diffPodel = math.cos(diffRadian)
            diffKolmo = math.sin(diffRadian) * klouzani
            self.speedUhel = self.carUhel + math.degrees(math.atan2(diffKolmo, diffPodel))
            #speedZmenseni = math.hypot(diffPodel, diffKolmo)
            #self.upSpeed *= speedZmenseni

            # pohyb v dusledku rychlosti
            radian = math.radians(self.speedUhel)
            self.polohax += self.upSpeed * math.cos(radian)
            self.polohay -= self.upSpeed * math.sin(radian)

            # meze auto
            if self.polohax < self.pulauta:
                    self.polohax = self.pulauta
            if self.polohax > mapax - self.pulauta:
                    self.polohax = mapax - self.pulauta

            if self.polohay < self.pulauta:
                    self.polohay = self.pulauta
            if self.polohay > mapay - self.pulauta:
                    self.polohay = mapay - self.pulauta

        def bum(self, kolega):
            """
            Resi narazy a aut a nasledne zmeny rychlosti.
            Nove rychlosti (speed) se vypoctou podle vztahu:

            speed1 = v1(m1-m2)/(m1+m2) + v2(2*m2)/(m1+m2)
            speed2 = v2(m2-m1)/(m1+m2) + v1(2*m1)/(m1+m2)
            """
            vzdalenost = (self.polohax - kolega.polohax)**2 \
            + (self.polohay - kolega.polohay)**2
            if vzdalenost < self.pulauta**2 + kolega.pulauta**2:
                    m1 = self.hmotnost
                    m2 = kolega.hmotnost
                    v1 = self.upSpeed
                    v2 = kolega.upSpeed
                    radian1 = math.radians(self.speedUhel)
                    radian2 = math.radians(kolega.speedUhel)
                    v1x = math.cos(radian1)*v1
                    v1y = math.sin(radian1)*v1
                    v2x = math.cos(radian2)*v2
                    v2y = math.sin(radian2)*v2

                    speed1x = (v1x*(m1-m2) + v2x*2*m2)/(m1+m2)
                    speed1y = (v1y*(m1-m2) + v2y*2*m2)/(m1+m2)
                    self.upSpeed = math.hypot(speed1x, speed1y)
                    self.speedUhel = math.degrees(math.atan2(speed1y, speed1x))
                    speed2x = (v2x*(m2-m1) + v1x*2*m1)/(m1+m2)
                    speed2y = (v2y*(m2-m1) + v1y*2*m1)/(m1+m2)
                    kolega.upSpeed = math.hypot(speed2x, speed2y)
                    kolega.speedUhel = math.degrees(math.atan2(speed2y, speed2x))

#-----------------------------------------------------------------
if __name__ == "__main__":
    import zavody

